from PyQt5.QtWidgets import QFrame
from PyQt5.QtCore import Qt
from PyQt5.QtGui import QPainter, QColor, QPen, QFont
import random
import time
from shape_PyQt5 import *



class GameBox(QFrame):
    def __init__(self, parent):
        super().__init__(parent)

    def init(self, x, y, boxw, w, h, messx, keyin):

        self.stick = [([0] * 22) for i in range(41)]
        self.px = x
        self.py = y
        self.boxwidth = boxw
        self.boxperline = w
        self.boxpercolumn = h
        self.pxmess = messx
        self.level = 1
        self.levelmess = None
        self.score = 0
        self.scoremess = None
        self.speed = 1
        self.speedmess = None
        self.layer = 3
        self.layermess = None
        self.inter = time.time()
        self.begin = 0
        for i in range(0, self.boxpercolumn):
            for j in range(1, self.boxperline + 1):
                self.stick[i][j] = 0
        for i in range(0, self.boxpercolumn):
            self.stick[i][0] = 1
            self.stick[i][self.boxperline + 1] = 1

        for j in range(0, self.boxperline + 2):
            self.stick[self.boxpercolumn][j] = 1

        self.controlkey = keyin

        self.curX = self.px
        self.curY = self.py
        self.width = 500
        self.height = 580

        self.update()

        self.curshape = Shape()
        self.curshape.init(
            self.px + self.boxwidth * (self.boxperline // 2 - 2), self.py,
            5 * self.boxwidth, 0, self.boxperline // 2 - 2, self.level)

    def gamebegin(self):
        i, j, b = 0, 0, 0
        randnum = [
            1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0,
            1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1,
            0, 1, 0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0,
            1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0,
            1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0,
            0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1,
            0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 0, 1,
            0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0,
            1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1,
            0, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0,
            0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1,
            0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 0, 0, 1,
            0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0,
            0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0,
            1, 0
        ]

        for i in range(0, self.boxpercolumn - 1):  # clear game box's stick
            for j in range(1, self.boxperline + 1):
                self.stick[i][j] = 0

        for i in range(0, self.layer):
            for j in range(1, self.boxperline + 1):
                b = random.randint(0, 20 - 1) + i
                self.stick[self.boxpercolumn - 1 - i][j] = randnum[b + j]

        self.curshape.getnextsh(
            self.px + self.boxwidth * (self.boxperline // 2 - 3), self.py, 0,
            self.boxperline // 2 - 2, self.level)
        self.score = 0
        self.begin = 1
        self.update()

        return 0

    def gameconfiged(self, key):
        if not key:
            return 0
        if key == self.controlkey[0]:
            self.level = (self.level + 1) % 4
        if key == self.controlkey[1]:
            return 1
        if key == self.controlkey[2]:
            self.speed = (self.speed + 1) % 10
        if key == self.controlkey[3]:
            self.layer = (self.layer + 1) % 10

        self.update()

        return 0

    def showmessage(self, canvas):
        mess = [' '] * 5

        canvas.drawText(self.px, 460, "http://www.zmofun.com")

        canvas.drawText(self.pxmess, self.py + 20, "LEVEL")
        mess = "%d" % self.level
        canvas.drawText(self.pxmess + 20 + 6, self.py + 40 + 2, mess)
        canvas.drawText(self.pxmess, self.py + 60, "SPEED")
        mess = "%d" % self.speed
        canvas.drawText(self.pxmess + 20 + 6, self.py + 80 + 2, mess)
        canvas.drawText(self.pxmess, self.py + 100, "LAYER")
        mess = "%d" % self.layer
        canvas.drawText(self.pxmess + 20 + 6, self.py + 120 + 2, mess)

        self.showscore(canvas)
        return 0

    def showscore(self, canvas):
        mess = [' '] * 8
        # settextstyle(0, 0, 1);
        mess = "%d" % self.score
        canvas.drawText(self.px + 50 + 6, self.py - 20 + 2, mess)
        return 0

    def addscore(self):
        i, j, line, ln, high, addspeed = 0, 0, 0, 0, 0, 0
        t = [0] * 40
        self.line = 0
        for i in range(self.boxpercolumn - 1, -1, -1):
            t[i] = 0
            for j in range(1, self.boxperline + 1):
                t[i] += self.stick[i][j]
            if t[i]:
                self.high = i
            if t[i] == self.boxperline:
                line = line + 1
                t[i] = 1
            else:
                t[i] = 0
        for i in range(self.boxpercolumn - 1, high - 1, -1):
            if t[i]:
                ln = i - 1
                while t[ln]:
                    ln = ln - 1
                for j in range(1, self.boxperline + 1):
                    self.stick[i][j] = self.stick[ln][j]
                    self.stick[ln][j] = 0
                t[ln] = 1

        addspeed = self.score // 1000
        if line > 3:
            self.score += 2 * line * 100
        else:
            self.score += line * 100
        if addspeed != self.score // 1000:
            self.speed = (self.speed + 1) % 10
        self.update()
        return 0

    def paintEvent(self, event):

        canvas = QPainter(self)
        #外框
        color = QColor(Qt.blue)
        canvas.setPen(QPen(Qt.blue, 1, Qt.SolidLine))
        canvas.fillRect(self.px - 1, self.py - 1,
                        self.px + self.boxperline * self.boxwidth + 1,
                        self.py + self.boxpercolumn * self.boxwidth + 1, color)

        canvas.fillRect(0, 0, self.width, self.height, color)

        canvas.setPen(QPen(Qt.yellow, 1, Qt.SolidLine))
        canvas.drawRect(self.px - 1, self.py - 1,
                        self.boxperline * self.boxwidth + 1,
                        self.boxpercolumn * self.boxwidth + 1)

        canvas.setPen(QColor(Qt.yellow))
        canvas.setFont(QFont('SimSun', 9))
        self.showmessage(canvas)

        self.paintstick(canvas)

        self.curshape.paint(canvas)
        self.curshape.paintnext(canvas, self.pxmess - 15, self.py + 200)

    def paintstick(self, canvas):
        i, j = 0, 0
        for i in range(0, self.boxpercolumn):
            for j in range(1, self.boxperline + 1):
                if self.stick[i][j]:
                    canvas.drawRect(self.px + self.boxwidth * (j - 1) + 1,
                                    self.py + self.boxwidth * i + 1,
                                    self.boxwidth - 2, self.boxwidth - 2)
        return 0

    def gameover(self):
        i, j = 0, 0
        if self.curshape.l < 1:
            return 1
        else:
            for i in range(0, 5):
                for j in range(0, 5):
                    if self.curshape.s[i][j]:
                        self.stick[i +
                                   self.curshape.l][self.curshape.c +
                                                    j] = self.curshape.s[i][j]
        self.addscore()
        return 0

    def canmove(self, direct):
        i, j = 0, 0
        if direct == 1:
            for j in range(0, 5):
                for i in range(0, 5):
                    if self.curshape.s[i][j] and self.stick[
                            self.curshape.l + i][self.curshape.c - 1 + j]:
                        return 0
        elif direct == 2:
            for j in range(4, -1, -1):
                for i in range(0, 5):
                    if self.curshape.s[i][j] and self.stick[
                            self.curshape.l + i][self.curshape.c + 1 + j]:
                        return 0
        elif direct == 3:
            for i in range(4, -1, -1):
                for j in range(0, 5):
                    if self.curshape.s[i][j] and self.stick[
                            self.curshape.l + 1 + i][self.curshape.c + j]:
                        return 0
        return 1

    def canrotate(self):
        i, j = 0, 0
        self.t = [([0] * 5) for i in range(0, 5)]
        for i in range(0, 5):
            for j in range(0, 5):
                self.t[i][j] = self.curshape.s[4 - j][i]
                if self.t[i][j] and self.stick[self.curshape.l +
                                               i][self.curshape.c + j]:
                    return 0
        return 1

    def play(self, key):
        if not self.begin:
            if self.gameconfiged(key):
                self.gamebegin()
            return 0
        if key == self.controlkey[0]:
            if self.canrotate():
                self.curshape.rotate()
        if key == self.controlkey[2]:
            if self.canmove(1):
                self.curshape.move(1)
        if key == self.controlkey[3]:
            if self.canmove(2):
                self.curshape.move(2)
        if key == self.controlkey[1]:
            if self.canmove(3):
                self.curshape.move(3)
        if (time.time() - self.inter) * 100 > (160 - 10 * self.level -
                                               10 * self.speed):
            if self.canmove(3):
                self.inter = time.time()
                self.curshape.move(3)
            else:
                if self.gameover():
                    self.begin = 0
                else:
                    self.curshape.getnextsh(
                        self.px + self.boxwidth * (self.boxperline // 2 - 3),
                        self.py, 0, self.boxperline // 2 - 2, self.level)
        self.update()
